program helper2;
{

  ("`-''-/").___..--''"`-._
 `6_ 6  )   `-.  (     ).`-.__.`)
 (_Y_.)'  ._   )  `._ `. ``-..-'
  _..`--'_..-_/  /--'_.' ,'
(il).-''  (li).'  ((!.-'

 Terminal Session Helper (Second Edition)
 Version 0.5

 Copyright © 2008-2010 Denis Fateyev (Денис Фатеев)
 Website: <http://www.fateyev.com>
 E-mail: <denis@fateyev.com>

 This program is free software; you can redistribute it and/or modify it under the terms
 of the GNU General Public License as published by the Free Software Foundation;
 either version 2 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with this program;
 if not, write to the Free Software Foundation, Inc.,
 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}
{$IFDEF FPC}
 {$MODE DELPHI}
 {$APPTYPE GUI}
{$ENDIF}

{$DEFINE SHOW_ERROR_MSG} // defines whether show users error messages or not
{$DEFINE USE_BIT_BUTTON} // defines whether using 'bit-button' style or not
{$DEFINE CRC32_CHECK}    // defines whether doing CRC-32 integrity checks or not
{$DEFINE 1C_INST_CHECK}  // defines wheher checking for running 1C instances or not
{$DEFINE USE_LOGGING}    // defines whether using logging facility or not

//-----------------------------------------------------
uses Windows, Messages, helper_MiscUtils
 {$IFDEF USE_BIT_BUTTON}, BitBtnApi {$ENDIF}
 {$IFDEF CRC32_CHECK}, crc32 {$ENDIF};

//-----------------------------------------------------
const
 WndClassName = 'TerminalHelper_Wnd';
 WndTitle = 'Terminal Session Helper';
 {$IFDEF 1C_INST_CHECK}
 Wnd1CTopClass = 'V8TopLevelFrame';
 Wnd1CNewClass = 'V8NewLocalFrameBaseWnd';
 {$ENDIF}
 dwFrequency = 500;
 dwDuration = 200;
 {$IFDEF CRC32_CHECK}
 dwSaltValue = $FEEDBEEF;
 bCalcSecCount = 3;
 {$ENDIF}

 // dialog's controls
 ID_MAINDLG = 100;
 ID_ICON_MAIN = 10;
 ID_LIST_MENU = 20;
 ID_BTN_START = 21;
 ID_BTN_CLOSE = 22;
 {$IFDEF USE_BIT_BUTTON}
  ID_ICO_START = 11;
  ID_ICO_CLOSE = 12;
 {$ENDIF}

 {$IFDEF SHOW_ERROR_MSG}
  strConfigFileError = 'Не найден файл конфигурации программы!' + #13#10 +
        'Обратитесь к системному администратору   ';
  strRunProgramError = 'Не удалось запустить программу!' + #13#10 +
        'Обратитесь к системному администратору   ';
  strRecMissingError = 'Отсутствует список доступных приложений!' + #13#10 +
        'Обратитесь к системному администратору       ';
  {$IFDEF CRC32_CHECK}
   strCrc32CheckError = 'Исполняемый файл программы поврежден!' + #13#10 +
        'Обратитесь к системному администратору   ';
  {$ENDIF}
 {$ENDIF}

 {$IFDEF 1C_INST_CHECK}
  str1CInstancePresent = 'Обнаружена запущенная копия "1С: Предприятие".' + #13#10 +
                         'Завершите все программы перед выходом из сеанса.  ';
 {$ENDIF}

 {$IFDEF USE_LOGGING}
  {$IFDEF CRC32_CHECK}
   strLogCrc32CalcError = 'Ошибка проверки целостности (расчет CRC32 не произведен), выход';
   strLogCrc32CheckError = 'Ошибка проверки целостности (расчетные значения не совпадают), выход';
  {$ENDIF}
  strLogInit = 'Инициализация программы';
  strLogConfigError = 'Ошибка конфигурации, выход';
  strLogShellPrivileges = 'Установлены привилегии на запуск оболочки';
  strLogStartProgram = 'Запуск пользовательской программы';
  strLogStartShell = 'Запуск оболочки пользователя';
  strLogStartDialog = 'Запуск в диалоговом режиме';
  strLogStartError = 'Ошибка запуска дочерней программы, выход';
  strLogExiting = 'Завершение работы программы';
  strRunningOn = ' (запуск произведен ';
 {$ENDIF}

//-----------------------------------------------------
var
 wc: WNDCLASSEX;
 hMainWnd: HWND;
 WMsg: TMsg;
 strConfigFile: string;
 strProgramRun: string;
 strProgramDir: string;
 bShellPrivileges: Boolean;
 bWaitForShellTerm: Boolean;
 bShowInitDialog: Boolean;
 arMenuIndex: array of Byte;
 iMenuItemCount: Integer;
 SInfo: STARTUPINFO;
 PInfo: PROCESS_INFORMATION;
 {$IFDEF CRC32_CHECK}
  dwCrc32Calc, dwCrc32Store: DWord;
  sectCalc, sectStored: PSectionsInfo;
  bStoreSecCount: Byte;
 {$ENDIF}
 {$IFDEF USE_LOGGING}
  strLogFile: string;
  strInitTime: string;
 {$ENDIF}
 {$IFDEF USE_BIT_BUTTON}
  hIconStart, hIconClose: HICON;
 {$ENDIF}

//-----------------------------------------------------
{$R Interface.res}
{$IFDEF USE_BIT_BUTTON}
 {$R BitButtons.res}
{$ENDIF}
//-----------------------------------------------------
// parse user privileges list
function FillPrivilegesTable: Boolean;
var
 tempStr, strUsername: string;
 i: Byte;

begin
 Result:= false; // default value is 'error'

 strConfigFile:= ExtractFilePath( ParamStr( 0 ) ) + 'helper.ini';
 if ( FileExists( strConfigFile ) ) then
 begin

   // adjust some initial parameters
   bShellPrivileges:= false;
   bShowInitDialog:= true;

   strUsername:= CharUpper( PChar( LoggedOnUserNameEx( dwNameSamCompatible ) ) );
   // the same mentioned below for IniReadString() is applicable for IniReadInteger()
   iMenuItemCount:= IniReadInteger( strConfigFile, 'Options', 'MenuItemCount', 0 );

   // NOTE: IniReadString() reads maximum only 1024 chars (bytes) from the parameter,
   // so if you want more please adjust 'Buffer' variable in the function's body
   tempStr := IniReadString( strConfigFile, 'Options', 'ShellPrivileges', '' );
   if ( tempStr <> '' ) then
    while ( tempStr <> '' ) do
       if ( strUsername = CharUpper( PChar( Parse( tempStr, ';' ) ) ) ) then
       begin
         bShellPrivileges:= true;
         bShowInitDialog:= false;
         strProgramRun:= IniReadString( strConfigFile, 'Options', 'Shell', '' );
         strProgramDir:= IniReadString( strConfigFile, 'Options', 'ShellDefaultDir', '' );
         {$IFDEF USE_LOGGING}
         AddLogFileLine( strLogFile, strLogShellPrivileges );
         {$ENDIF}
         Break;
       end;

   if ( not bShellPrivileges ) then
   for i:= 1 to iMenuItemCount do
   begin
     // NOTE: IniReadString() reads maximum only 1024 chars (bytes) from the parameter,
     // so if you want more please adjust 'Buffer' variable in the function's body
     tempStr := IniReadString( strConfigFile, 'Options', 'Set' +Int2Str( i ) + 'Privileges', '' );
     if ( tempStr <> '' ) then
     while ( tempStr <> '' ) do
       if ( strUsername = CharUpper( PChar( Parse( tempStr, ';' ) ) ) ) then
       begin
         bShowInitDialog:= false;
         strProgramRun:= IniReadString( strConfigFile, 'Options', 'Program' + Int2Str( i ) +'Run', '' );
         strProgramDir:= IniReadString( strConfigFile, 'Options', 'Program' + Int2Str( i ) + 'DefaultDir', '' );
         Break;
       end;

   end  // 'if ( not bShellPrivileges ) then'
    else
   begin
     // adjust 'wait for shell termination' parameter
     bWaitForShellTerm:= true;
     tempStr:= IniReadString( strConfigFile, 'Options', 'WaitShellTerminate', 'TRUE' );
     strUsername:= CharUpper( PChar( tempStr ) );
     if ( strUsername = 'FALSE' ) then bWaitForShellTerm:= false;
   end;  // 'if ( not bShellPrivileges ) then'

   if ( bShowInitDialog ) then
    // initialize menu list
    for i:= 1 to iMenuItemCount do
     begin
       tempStr := IniReadString( strConfigFile, 'Options', 'Program' +Int2Str( i ) + 'MenuCaption', '' );
       if ( tempStr <> '' ) then
       begin
         SetLength( arMenuIndex, Length( arMenuIndex ) + 1 );
         arMenuIndex[ Length( arMenuIndex ) - 1 ]:= i;
       end;
     end;  // 'if ( bShowInitDialog ) then'

   Result:= true;
 end;
end;


//-----------------------------------------------------
// main window procedure
function MainWndProc( Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall;
var
 hMenuWnd: HMENU;
 i: Byte;
 {$IFDEF USE_BIT_BUTTON}
  DrawItem: PDrawItemStruct;
 {$ENDIF}

begin
 Result:= 0; // STUB
 case ( Msg ) of

   // WM_SHOWWINDOW
   WM_SHOWWINDOW:
   if ( bShowInitDialog ) then

    // interactive dialog mode
    begin
      {$IFDEF USE_LOGGING}
       // running interactive session
       AddLogFileLine( strLogFile, strLogStartDialog );
      {$ENDIF}
      SetWindowText( Wnd, PChar( IniReadString( strConfigFile, 'Options', 'DialogCaption', '' ) ) );
      SetWindowText( GetDlgItem( Wnd, ID_BTN_START ), PChar( IniReadString( strConfigFile, 'Options', 'StartBtnCaption', '' ) ) );
      SetWindowText( GetDlgItem( Wnd, ID_BTN_CLOSE ), PChar( IniReadString( strConfigFile, 'Options', 'CloseBtnCaption', '' ) ) );
      {$IFDEF USE_BIT_BUTTON}
       hIconStart:= LoadImage( hInstance, PChar( ID_ICO_START ), IMAGE_ICON, 0, 0, LR_SHARED );
       hIconClose:= LoadImage( hInstance, PChar( ID_ICO_CLOSE ), IMAGE_ICON, 0, 0, LR_SHARED );
       Attach_BitBtnStyle( GetDlgItem( Wnd, ID_BTN_START ) );
       Attach_BitBtnStyle( GetDlgItem( Wnd, ID_BTN_CLOSE ) );
      {$ENDIF}

      SendMessage( Wnd, WM_SETICON, ICON_BIG, LoadIcon( hInstance, PChar( ID_ICON_MAIN ) ) );
      hMenuWnd:= GetSystemMenu( Wnd, false );
      // disable 'maximize' command (menu item with 'idx 4' on 2k/XP/2k3)
      DeleteMenu( hMenuWnd, 4, MF_BYPOSITION );

      // fill menu list items
      if ( Length( arMenuIndex ) > 0 ) then
      begin
        for i:= 1 to Length( arMenuIndex ) do
         SendMessage( GetDlgItem( Wnd, ID_LIST_MENU ), LB_ADDSTRING, 0,
          Integer( PChar( IniReadString( strConfigFile, 'Options', 'Program' + Int2Str( arMenuIndex[ i-1 ] ) + 'MenuCaption', '' ) ) ) );
        SendMessage( GetDlgItem( Wnd, ID_LIST_MENU ), LB_SETITEMHEIGHT, 0, 14 );
        SendMessage( GetDlgItem( Wnd, ID_LIST_MENU ), LB_SETCURSEL, 0, 0 );
        SendMessage( GetDlgItem( Wnd, ID_LIST_MENU ), WM_SETFOCUS, 0, 0 );
      end
      else
      begin
        {$IFDEF SHOW_ERROR_MSG}
          {$IFDEF FPC}
          MessageBox( GetForegroundWindow, PChar( UTF8ToAnsi( strRecMissingError ) ), PChar( UTF8ToAnsi( WndTitle ) ), MB_ICONERROR );
          {$ELSE}
          MessageBox( GetForegroundWindow, PChar( strRecMissingError ), PChar( WndTitle ), MB_ICONERROR );
          {$ENDIF}
        {$ENDIF}
        Beep( dwFrequency, dwDuration );
        SendMessage( hMainWnd, WM_CLOSE, 0, 0 );
      end;

    end
   else

    // single (hidden) window mode
    begin
      ZeroMemory( @SInfo, SizeOf( STARTUPINFO ) );
      with SInfo do
      begin
        cb:= SizeOf( STARTUPINFO );
        dwFlags:= STARTF_USESHOWWINDOW;
        wShowWindow:= SW_SHOW;
      end;

      {$IFDEF USE_LOGGING}
      if ( bShellPrivileges ) then
       // running specified shell program
       AddLogFileLine( strLogFile, strLogStartShell + ' (''' + strProgramRun + ''')' )
      else
       // running program specified in config file
       AddLogFileLine( strLogFile, strLogStartProgram + ' (''' + strProgramRun + ''')' );
      {$ENDIF}

      SetCurrentDirectory( PChar( strProgramDir ) );
      CreateProcess( nil, PChar( strProgramRun ), nil, nil, false, NORMAL_PRIORITY_CLASS, nil, nil, SInfo, PInfo );

      // waiting for program termination
      if ( PInfo.hProcess > 0 ) then
      begin
        if  ( not ( ( bShellPrivileges ) and ( not bWaitForShellTerm ) ) ) then
         WaitForSingleObject( PInfo.hProcess, INFINITE );
      end
       else
       begin
         {$IFDEF USE_LOGGING}
         AddLogFileLine( strLogFile, strLogStartError + ' (''' + strProgramRun + ''')' );
         {$ENDIF}
         {$IFDEF SHOW_ERROR_MSG}
           {$IFDEF FPC}
           MessageBox( GetForegroundWindow, PChar( UTF8ToAnsi( strRunProgramError ) ), PChar( UTF8ToAnsi( WndTitle ) ), MB_ICONERROR );
           {$ELSE}
           MessageBox( GetForegroundWindow, PChar( strRunProgramError ), PChar( WndTitle ), MB_ICONERROR );
           {$ENDIF}
         {$ENDIF}
         Beep( dwFrequency, dwDuration );
       end;

      // close window immediately when the child process terminated
      SendMessage( hMainWnd, WM_CLOSE, 0, 0 );

    end; // 'WM_SHOWWINDOW'

    // WM_COMMAND
    WM_COMMAND:
    // I assume that our fuzzy window doesn't send any of WM_COMMAND messages
    // (actually, an interactive dialog window only does it)
     if ( bShowInitDialog ) then
     begin
       case Lo( WParam ) of

        // ID_BTN_START
        ID_BTN_START:
        begin
          ZeroMemory( @SInfo, SizeOf( STARTUPINFO ) );
          with SInfo do
          begin
            cb:= SizeOf( STARTUPINFO );
            dwFlags:= STARTF_USESHOWWINDOW;
            wShowWindow:= SW_SHOW;
          end;

          i:= SendMessage( GetDlgItem( Wnd, ID_LIST_MENU ), LB_GETCURSEL, 0, 0 );
          strProgramRun:= IniReadString( strConfigFile, 'Options', 'Program' + Int2Str( arMenuIndex[ i ] ) +'Run', '' );
          strProgramDir:= IniReadString( strConfigFile, 'Options', 'Program' + Int2Str( arMenuIndex[ i ] ) + 'DefaultDir', '' );

          {$IFDEF USE_LOGGING}
          // running program specified in config file
          AddLogFileLine( strLogFile, strLogStartProgram + ' (''' + strProgramRun + ''')' );
          {$ENDIF}

          SetCurrentDirectory( PChar( strProgramDir ) );
          CreateProcess( nil, PChar( strProgramRun ), nil, nil, false, NORMAL_PRIORITY_CLASS, nil, nil, SInfo, PInfo );

          // checking result (if the user program was run successfully)
          if ( PInfo.hProcess < 1 ) then
          begin
           {$IFDEF USE_LOGGING}
           AddLogFileLine( strLogFile, strLogStartError + ' (''' + strProgramRun + ''')' );
           {$ENDIF}
           {$IFDEF SHOW_ERROR_MSG}
             {$IFDEF FPC}
             MessageBox( GetForegroundWindow, PChar( UTF8ToAnsi( strRunProgramError ) ), PChar( UTF8ToAnsi( WndTitle ) ), MB_ICONERROR );
             {$ELSE}
             MessageBox( GetForegroundWindow, PChar( strRunProgramError ), PChar( WndTitle ), MB_ICONERROR );
             {$ENDIF}
           {$ENDIF}
           Beep( dwFrequency, dwDuration );
          end;

        end;  // 'ID_BTN_START'

        // ID_BTN_CLOSE
        ID_BTN_CLOSE:
          SendMessage( hMainWnd, WM_CLOSE, 0, 0 );

        // ID_LIST_MENU
        ID_LIST_MENU:
         if ( HiWord( WParam ) = LBN_DBLCLK ) then
          SendMessage( Wnd, WM_COMMAND, ID_BTN_START, 0 );

       end;  // 'case' end
     end;

     {$IFDEF USE_BIT_BUTTON}
     // WM_DRAWITEM
     WM_DRAWITEM:
      begin
       DrawItem:= PDrawItemStruct( lParam );
       if ( DrawItem.CtlType = ODT_BUTTON ) then
        begin
          case DrawItem.CtlID of

            // ID_BTN_START
            ID_BTN_START:
              BitBtn_Draw( hIconStart, DrawItem );

            // ID_BTN_CLOSE
            ID_BTN_CLOSE:
              BitBtn_Draw( hIconClose, DrawItem );
          end; // 'case' end

        end;
      end;
      {$ENDIF}

    // WM_QUERYENDSESSION
    WM_QUERYENDSESSION: Result:= 1; // application can terminate conveniently

    // WM_CLOSE, WM_ENDSESSION
    WM_CLOSE, WM_ENDSESSION:
     {$IFDEF 1C_INST_CHECK}
     if ( bShowInitDialog ) then
     begin
       if ( ( FindWindow( Wnd1CTopClass, nil ) > 0 ) or
            ( FindWindow( Wnd1CNewClass, nil ) > 0 ) ) then
        {$IFDEF FPC}
        MessageBox( GetForegroundWindow, PChar( UTF8ToAnsi( str1CInstancePresent ) ), PChar( UTF8ToAnsi( WndTitle ) ), MB_ICONASTERISK )
        {$ELSE}
        MessageBox( GetForegroundWindow, PChar( str1CInstancePresent ), PChar( WndTitle ), MB_ICONASTERISK )
        {$ENDIF}
       else DestroyWindow( hMainWnd );
     end
     else
     {$ENDIF}
      DestroyWindow( hMainWnd );

    // WM_DESTROY
    WM_DESTROY:
    begin
      SetLength( arMenuIndex, 0 );
      {$IFDEF USE_LOGGING}
      AddLogFileLine( strLogFile, strLogExiting + strRunningOn + strInitTime + ')' );
      {$ENDIF}
      {$IFDEF USE_BIT_BUTTON}
        // There isn't needed to detach button styles,
        // because program terminates at this stage anyway
        //Detach_BitBtnStyle( GetDlgItem( Wnd, ID_BTN_START ) );
        //Detach_BitBtnStyle( GetDlgItem( Wnd, ID_BTN_CLOSE ) );
      {$ENDIF}
      PostQuitMessage( 0 );
      Result:= 0;
    end

    // we're using DefWindowProc() even for the dialog window (it works!)
    else Result:= DefWindowProc( Wnd, Msg, wParam, lParam );  // default handler proc
  end; // 'case' end

end;

//-----------------------------------------------------

begin
{$IFDEF USE_LOGGING}
 // set log filename
 strInitTime:= DateTimeNowToStr;
 strLogFile:= ExtractFilePath( ParamStr( 0 ) ) + 'helper.log';
 AddLogFileLine( strLogFile, strLogInit );
{$ENDIF}

{$IFDEF CRC32_CHECK}
 // checking file integrity
 New( sectCalc );
 ZeroMemory( sectCalc, SizeOf( TSectionsInfo ) );
 // protected sections definition
 sectCalc[0].bIndex:= 0; // CODE  (.text with FPC}
 sectCalc[1].bIndex:= 1; // DATA  (.data with FPC}
 {$IFDEF FPC}
 sectCalc[2].bIndex:= 4; // .rsrc
 {$ELSE}
 sectCalc[2].bIndex:= 7; // .rsrc
 {$ENDIF}
 // don't forget to adjust bCalcSecCount if you're changing sectCalc.

 // calculate current values for the executable
 if ( not Crc32Self_Sections( sectCalc, bCalcSecCount, dwCrc32Calc ) ) then
 begin
   {$IFDEF USE_LOGGING}
   AddLogFileLine( strLogFile, strLogCrc32CalcError + strRunningOn + strInitTime + ')' );
   {$ENDIF}
   {$IFDEF SHOW_ERROR_MSG}
     {$IFDEF FPC}
     MessageBox( GetForegroundWindow, PChar( UTF8ToAnsi( strCrc32CheckError ) ), PChar( UTF8ToAnsi( WndTitle ) ), MB_ICONERROR );
     {$ELSE}
     MessageBox( GetForegroundWindow, PChar( strCrc32CheckError ), PChar( WndTitle ), MB_ICONERROR );
     {$ENDIF}
   {$ENDIF}
   Beep( dwFrequency, dwDuration );
   Dispose( sectCalc );
   Exit;
 end;

 // retrieve stored information from the executable
 New( sectStored );
 ZeroMemory( sectStored, SizeOf( TSectionsInfo ) );
 Crc32Stored_Sections( sectStored, bStoreSecCount, dwSaltValue, dwCrc32Store );
 if ( ( not CompareMem( sectCalc, sectStored, SizeOf( TSectionsInfo ) ) ) or
             ( dwCrc32Calc <> dwCrc32Store ) or ( bCalcSecCount <> bStoreSecCount ) ) then
 begin
   {$IFDEF USE_LOGGING}
   AddLogFileLine( strLogFile, strLogCrc32CheckError + strRunningOn + strInitTime + ')' );
   {$ENDIF}
   {$IFDEF SHOW_ERROR_MSG}
     {$IFDEF FPC}
     MessageBox( GetForegroundWindow, PChar( UTF8ToAnsi( strCrc32CheckError ) ), PChar( UTF8ToAnsi( WndTitle ) ), MB_ICONERROR );
     {$ELSE}
     MessageBox( GetForegroundWindow, PChar( strCrc32CheckError ), PChar( WndTitle ), MB_ICONERROR );
     {$ENDIF}
   {$ENDIF}
   Beep( dwFrequency, dwDuration );
   Dispose( sectStored );
   Dispose( sectCalc );
   Exit;
 end;

 Dispose( sectStored );
 Dispose( sectCalc );
{$ENDIF}

 // create specific window class
 with wc do
 begin
  cbSize:= SizeOf( wc );
  style:= CS_DBLCLKS + CS_HREDRAW + CS_VREDRAW;
  lpfnWndProc:= @MainWndProc;
  cbClsExtra:= 0;
  cbWndExtra:= DLGWINDOWEXTRA;
  hCursor:= LoadCursor( 0, IDC_ARROW );
  hIcon:= LoadIcon( hInstance, PChar( ID_ICON_MAIN ) );
  hIconSm:= LoadIcon( hInstance, PChar( ID_ICON_MAIN ) );
  hbrBackground:= COLOR_BTNFACE + 1;
  lpszMenuName:= nil;
  lpszClassName:= WndClassName;
 end;
 RegisterClassEx( wc );  // register new window class

 // checking user privileges (fill privileges parameters)
 if ( not FillPrivilegesTable ) then
 begin
   {$IFDEF USE_LOGGING}
   AddLogFileLine( strLogFile, strLogConfigError );
   {$ENDIF}
   // notify the user when error occured
   {$IFDEF SHOW_ERROR_MSG}
     {$IFDEF FPC}
     MessageBox( GetForegroundWindow, PChar( UTF8ToAnsi( strConfigFileError ) ), PChar( UTF8ToAnsi( WndTitle ) ), MB_ICONERROR );
     {$ELSE}
     MessageBox( GetForegroundWindow, PChar( strConfigFileError ), PChar( WndTitle ), MB_ICONERROR );
     {$ENDIF}
   {$ENDIF}
   Beep( dwFrequency, dwDuration );
   Exit;
 end;

 if ( bShowInitDialog ) then
  // create dialog window with specific window class
  hMainWnd:= CreateDialogParam( hInstance, PChar( ID_MAINDLG ), 0, nil, 0 )

 else
  // create trivial window with specific window class
  hMainWnd:= CreateWindow( WndClassName, WndTitle, WS_OVERLAPPEDWINDOW,
                            50, 100, 350, 200, 0, 0, hInstance, nil );

 ShowWindow( hMainWnd, SW_SHOW ); // generate WM_SHOWWINDOW message

 // infinite messages processing loop
 while ( GetMessage( WMsg, 0, 0, 0 ) ) do
 begin
  TranslateMessage( WMsg );
  DispatchMessage( WMsg );
 end;

//-----------------------------------------------------


end.

